bennaDesilatrice = {};
function bennaDesilatrice.prerequisitesPresent(specializations) return true; end;
function bennaDesilatrice:load(xmlFile) self.isReset = false; self.isResetFill = false;
	self.setcurrentCoperchio = SpecializationUtil.callSpecializationsFunction("setcurrentCoperchio"); self.currentCoperchio = 1;
	self.capacity = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.capacity"), 0.0); end;
function bennaDesilatrice:readStream(streamId, connection) self:setcurrentCoperchio(streamReadInt8(streamId), true); end;
function bennaDesilatrice:writeStream(streamId, connection)	streamWriteInt8(streamId, self.currentCoperchio); end;
function bennaDesilatrice:setcurrentCoperchio(int, noEventSend) self.currentCoperchio = int; setcurrentCoperchioEvent.sendEvent(self, int, noEventSend); end;
function bennaDesilatrice:loadFromAttributesAndNodes(xmlFile, key, resetVehicles) local currentCoperchio = getXMLInt(xmlFile, key .. "#currentCoperchio"); if currentCoperchio ~= nil then self:setcurrentCoperchio(currentCoperchio-1); end;
	return BaseMission.VEHICLE_LOAD_OK; end;
function bennaDesilatrice:getSaveAttributesAndNodes(nodeIdent) local attributes = 'currentCoperchio="' .. self.currentCoperchio .. '"'; return attributes; end;
function bennaDesilatrice:delete() end;
function bennaDesilatrice:mouseEvent(posX, posY, isDown, isUp, button) end;
function bennaDesilatrice:keyEvent(unicode, sym, modifier, isDown) end;
function bennaDesilatrice:update(dt) if g_currentMission.player ~= nil and g_currentMission.player.isEntered then
	local px, py, pz = getWorldTranslation(g_currentMission.player.rootNode); local tx, ty, tz = getWorldTranslation(self.components[1].node);
	if Utils.vector3Length(px-tx, py-ty, pz-tz) < 3 then if InputBinding.hasEvent(InputBinding.change) then	if self.currentCoperchio == 1 then self:setcurrentCoperchio(2); elseif self.currentCoperchio == 3 then self:setcurrentCoperchio(0); end; end;
	if self.currentCoperchio == 3 then g_currentMission:addHelpButtonText(string.format(g_i18n:getText("forcaApri"), self.typeDesc), InputBinding.change); else g_currentMission:addHelpButtonText(string.format(g_i18n:getText("forcaChiudi") , self.typeDesc), InputBinding.change); end; end; end;
	if self:getIsActiveForInput() then if self:getIsTurnedOn() and self.fillLevel < self.capacity and self.isResetFill == false then self.isResetFill = true; end; if (self.fillLevel == self.capacity or not self:getIsTurnedOn()) and self.isResetFill == true then self.isResetFill = false; end; end; end;
function bennaDesilatrice:loadFromAttributesAndNodes(xmlFile, key, resetVehicles) return BaseMission.VEHICLE_LOAD_OK; end;
function bennaDesilatrice:getSaveAttributesAndNodes(nodeIdent) end;
function bennaDesilatrice:updateTick(dt)
	if self.currentCoperchio == 0 then self:playAnimation("fermi", -1); self.currentCoperchio = 1;
	elseif self.currentCoperchio == 2 then self:playAnimation("fermi", 1); self.currentCoperchio = 3; end;
	if self.isReset == false then self:setcurrentCoperchio(self.currentCoperchio-1); if self.currentAttacco == 4 then self:playAnimation("tubiIdraulici", -1); end; self.isReset = true; end; 
	if self.isResetFill == true and self.fillLevel < self.capacity then self:playAnimation("baleTrigger", 1); else self:playAnimation("baleTrigger", -1); end; end;
function bennaDesilatrice:draw() end;
function bennaDesilatrice:onAttach(attacherVehicle, jointDescIndex)  self.isReset = false; self:playAnimation("tubiIdraulici", 1); end;
function bennaDesilatrice:onDetach() self:playAnimation("tubiIdraulici", -1); end;
function bennaDesilatrice:onDeactivate() end;
setcurrentCoperchioEvent = {}; setcurrentCoperchioEvent_mt = Class(setcurrentCoperchioEvent, Event); InitEventClass(setcurrentCoperchioEvent, "setcurrentCoperchioEvent");
function setcurrentCoperchioEvent:emptyNew() local self = Event:new(setcurrentCoperchioEvent_mt); self.className="setcurrentCoperchioEvent"; return self; end;
function setcurrentCoperchioEvent:new(vehicle, currentCoperchio) local self = setcurrentCoperchioEvent:emptyNew() self.vehicle = vehicle; self.currentCoperchio = currentCoperchio; return self; end;
function setcurrentCoperchioEvent:readStream(streamId, connection) local id = streamReadInt32(streamId); self.vehicle = networkGetObject(id);  
self.currentCoperchio = streamReadInt8(streamId); self.vehicle:setcurrentCoperchio(self.currentCoperchio, true);
	if not connection:getIsServer() then g_server:broadcastEvent(setcurrentCoperchioEvent:new(self.vehicle, self.currentCoperchio), nil, connection, self.vehicle); end; end;
function setcurrentCoperchioEvent:writeStream(streamId, connection) streamWriteInt32(streamId, networkGetObjectId(self.vehicle)); streamWriteInt8(streamId, self.currentCoperchio); end;
function setcurrentCoperchioEvent.sendEvent(vehicle, currentCoperchio, noEventSend) if noEventSend == nil or noEventSend == false then
	if g_server ~= nil then	g_server:broadcastEvent(setcurrentCoperchioEvent:new(vehicle, currentCoperchio), nil, nil, vehicle);
	else g_client:getServerConnection():sendEvent(setcurrentCoperchioEvent:new(vehicle, currentCoperchio)); end; end; end;