lamaDozer = {};
function lamaDozer.prerequisitesPresent(specializations) return true end;
function lamaDozer:load(xmlFile) self.indexMass = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.indexMass#index"));
	self.setcurrentMobile = SpecializationUtil.callSpecializationsFunction("setcurrentMobile"); self.currentMobile = 3; 
	self.setcurrentPeso = SpecializationUtil.callSpecializationsFunction("setcurrentPeso"); self.currentPeso = 0;
	self.extraWeightsDefaultMass = getMass(self.components[1].node);
	self.fillVolume1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fillVolume1#index")); end;
function lamaDozer:readStream(streamId, connection) self:setcurrentMobile(streamReadInt8(streamId), true); self:setcurrentPeso(streamReadInt8(streamId), true); end;
function lamaDozer:writeStream(streamId, connection) streamWriteInt8(streamId, self.currentMobile); streamWriteInt8(streamId, self.currentPeso); end;
function lamaDozer:setcurrentMobile(int, noEventSend) self.currentMobile = int; setcurrentMobileEvent.sendEvent(self, int, noEventSend); end;
function lamaDozer:setcurrentPeso(int, noEventSend) self.currentPeso = int; setcurrentPesoEvent.sendEvent(self, int, noEventSend); end;
function lamaDozer:loadFromAttributesAndNodes(xmlFile, key, resetVehicles) 	local currentMobile = getXMLInt(xmlFile, key .. "#currentMobile"); if currentMobile ~= nil then self:setcurrentMobile(currentMobile-1); end; local currentPeso = getXMLInt(xmlFile, key .. "#currentPeso"); if currentPeso ~= nil then self:setcurrentPeso(currentPeso-1); end; return BaseMission.VEHICLE_LOAD_OK; end;
function lamaDozer:getSaveAttributesAndNodes(nodeIdent) local attributes = ' currentMobile="' .. self.currentMobile .. '" currentPeso="' .. self.currentPeso .. '"'; return attributes; end;
function lamaDozer:delete() end;
function lamaDozer:mouseEvent(posX, posY, isDown, isUp, button) end;
function lamaDozer:keyEvent(unicode, sym, modifier, isDown) end;
function lamaDozer:update(dt) if g_currentMission.player ~= nil and g_currentMission.player.isEntered then
	local px, py, pz = getWorldTranslation(g_currentMission.player.rootNode); local tx, ty, tz = getWorldTranslation(self.components[1].node);
	if Utils.vector3Length(px-tx, py-ty, pz-tz) < 3 then if InputBinding.hasEvent(InputBinding.OpenClose) then 
	if self.currentMobile == 1 and self.fillLevel == 0 then self:setcurrentMobile(2);
	elseif self.currentMobile == 3 then self:setcurrentMobile(0); end; end; 
	if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA2) then if self.currentPeso == 1 then self:setcurrentPeso(2); elseif self.currentPeso == 3 then self:setcurrentPeso(0); end; end;
	if self.currentMobile == 1 and self.fillLevel == 0 then g_currentMission:addHelpButtonText(g_i18n:getText("forcaApri"), InputBinding.OpenClose); elseif self.currentMobile == 3 then g_currentMission:addHelpButtonText(g_i18n:getText("forcaChiudi"), InputBinding.OpenClose); end; if self.currentPeso == 1 then g_currentMission:addHelpButtonText(g_i18n:getText("pesoOn"), InputBinding.IMPLEMENT_EXTRA2); elseif self.currentPeso == 3 then g_currentMission:addHelpButtonText(g_i18n:getText("pesoOff"), InputBinding.IMPLEMENT_EXTRA2); end; end; end; end;
function lamaDozer:updateTick(dt) if self.currentMobile == 3 and self.fillLevel > 0 then self.currentMobile = 0; end;
	if self.currentMobile == 0 then self:playAnimation("telaioMobile", 1); self:setcurrentMobile(1); elseif self.currentMobile == 2 then self:playAnimation("telaioMobile", -1); self:setcurrentMobile(3); end;
	if self.currentPeso == 0 then setVisibility(self.indexMass, false); setMass(self.components[1].node, self.extraWeightsDefaultMass); self:setcurrentPeso(1); elseif self.currentPeso == 2 then setVisibility(self.indexMass, true); setMass(self.components[1].node, self.extraWeightsDefaultMass + 0.2); self:setcurrentPeso(3); end; end;
function lamaDozer:draw() end;
function lamaDozer:onAttach() end;
function lamaDozer:onDetach() end;
function lamaDozer:onDeactivate() end;
setcurrentMobileEvent = {}; setcurrentMobileEvent_mt = Class(setcurrentMobileEvent, Event); InitEventClass(setcurrentMobileEvent, "setcurrentMobileEvent");
function setcurrentMobileEvent:emptyNew() local self = Event:new(setcurrentMobileEvent_mt); self.className="setcurrentMobileEvent"; return self; end;
function setcurrentMobileEvent:new(vehicle, currentMobile) local self = setcurrentMobileEvent:emptyNew() self.vehicle = vehicle; self.currentMobile = currentMobile; return self; end;
function setcurrentMobileEvent:readStream(streamId, connection) local id = streamReadInt32(streamId);
    self.vehicle = networkGetObject(id); self.currentMobile = streamReadInt8(streamId); self.vehicle:setcurrentMobile(self.currentMobile, true);
	if not connection:getIsServer() then g_server:broadcastEvent(setcurrentMobileEvent:new(self.vehicle, self.currentMobile), nil, connection, self.vehicle); end; end;
function setcurrentMobileEvent:writeStream(streamId, connection) streamWriteInt32(streamId, networkGetObjectId(self.vehicle)); streamWriteInt8(streamId, self.currentMobile); end;
function setcurrentMobileEvent.sendEvent(vehicle, currentMobile, noEventSend) if noEventSend == nil or noEventSend == false then
	if g_server ~= nil then	g_server:broadcastEvent(setcurrentMobileEvent:new(vehicle, currentMobile), nil, nil, vehicle);
	else g_client:getServerConnection():sendEvent(setcurrentMobileEvent:new(vehicle, currentMobile)); end; end; end;
setcurrentPesoEvent = {}; setcurrentPesoEvent_mt = Class(setcurrentPesoEvent, Event); InitEventClass(setcurrentPesoEvent, "setcurrentPesoEvent");
function setcurrentPesoEvent:emptyNew() local self = Event:new(setcurrentPesoEvent_mt); self.className="setcurrentPesoEvent"; return self; end;
function setcurrentPesoEvent:new(vehicle, currentPeso) local self = setcurrentPesoEvent:emptyNew() self.vehicle = vehicle; self.currentPeso = currentPeso; return self; end;
function setcurrentPesoEvent:readStream(streamId, connection) local id = streamReadInt32(streamId);
    self.vehicle = networkGetObject(id); self.currentPeso = streamReadInt8(streamId); self.vehicle:setcurrentPeso(self.currentPeso, true);
	if not connection:getIsServer() then g_server:broadcastEvent(setcurrentPesoEvent:new(self.vehicle, self.currentPeso), nil, connection, self.vehicle); end; end;
function setcurrentPesoEvent:writeStream(streamId, connection) streamWriteInt32(streamId, networkGetObjectId(self.vehicle)); streamWriteInt8(streamId, self.currentPeso); end;
function setcurrentPesoEvent.sendEvent(vehicle, currentPeso, noEventSend) if noEventSend == nil or noEventSend == false then
	if g_server ~= nil then	g_server:broadcastEvent(setcurrentPesoEvent:new(vehicle, currentPeso), nil, nil, vehicle);
	else g_client:getServerConnection():sendEvent(setcurrentPesoEvent:new(vehicle, currentPeso)); end; end; end;